/*!
 * jQuery formFiller Plugin
 * Examples and documentation at: http://jellypirate.org/formfiller
 * Copyright (c) 2011 S. Lövgren
 * Version: 1.0.0 (11-NOV-2011)
 *
 * Dual licensed under the MIT and GPL licenses.
 * http://jellypirate.org/license
 * Requires: jQuery v1.4.4 or later
 */
(function( $ ){

  $.fn.formFiller = function( options ) {  

    var settings = {
      'content' : '',
	  'color' : '#999',
	  'bg' : '',
	  'attr' : '',
	  'bold' : false,
	  'italic' : false 
    };

    return this.each(function() { 
      // If options exist, lets merge them
      // with our default settings
      if ( options ) { $.extend( settings, options ); }
	  
	  // if filler not exist, use custom attribute. If not custom attr set, use alt attr.
	  if(!settings['content']){
		if(!settings['attr']){ this.filler = $(this).attr('alt'); }
		else{ this.filler = $(this).attr(settings['attr']); }  
	  }
	  else{ this.filler = settings['content']; }
	  
	  
	  this.bold = '';
	  if(settings['bold']){ this.bold = 'bold'; }
	  this.italic = '';
	  if(settings['italic']){ this.italic = 'italic'; }
	  
	  
	  // Insert filler from start
	  if($(this).attr('value') == ''){
	  $(this).attr('value', this.filler).css('color',settings['color']).css('background',settings['bg']).css('font-weight',this.bold).css('font-style',this.italic);
	  }
	  // Remove filler on focus
	  $(this).focusin(function(){
			if($(this).attr('value') == this.filler){
				$(this).attr('value', '').css('color','').css('background','').css('font-weight','').css('font-style','');
			}
	  });
	  // Add filler if form is empty
	  $(this).focusout(function(){
			if($(this).attr('value')== ''){
				$(this).attr('value', this.filler).css('color',settings['color']).css('background',settings['bg']).css('background',settings['bg']).css('font-weight',this.bold).css('font-style',this.italic);
			}
	  });
      

    });

  };
})( jQuery );